Ext.data.Model
Alternate names
Ext.data.RecordHierarchy
Ext.BaseExt.data.ModelMixins
Requires
Files
Guide
A Model represents some object that your application manages. For example, one might define a Model for Users, Products, Cars, or any other real-world object that we want to model in the system. Models are registered via the model manager, and are used by stores, which are in turn used by many of the data-bound components in Ext.
Models are defined as a set of fields and any arbitrary methods and properties relevant to the model. For example:
Ext.define('User', {
extend: 'Ext.data.Model',
config: {
fields: [
{name: 'name', type: 'string'},
{name: 'age', type: 'int'},
{name: 'phone', type: 'string'},
{name: 'alive', type: 'boolean', defaultValue: true}
]
},
changeName: function() {
var oldName = this.get('name'),
newName = oldName + " The Barbarian";
this.set('name', newName);
}
});
The fields array is turned into a MixedCollection automatically by the ModelManager, and all other functions and properties are copied to the new Model's prototype.
Now we can create instances of our User model and call any model logic we defined:
var user = Ext.create('User', {
name : 'Conan',
age : 24,
phone: '555-555-5555'
});
user.changeName();
user.get('name'); //returns "Conan The Barbarian"
Validations
Models have built-in support for validations, which are executed against the validator functions in Ext.data.validations (see all validation functions). Validations are easy to add to models:
Ext.define('User', {
extend: 'Ext.data.Model',
config: {
fields: [
{name: 'name', type: 'string'},
{name: 'age', type: 'int'},
{name: 'phone', type: 'string'},
{name: 'gender', type: 'string'},
{name: 'username', type: 'string'},
{name: 'alive', type: 'boolean', defaultValue: true}
],
validations: [
{type: 'presence', field: 'age'},
{type: 'length', field: 'name', min: 2},
{type: 'inclusion', field: 'gender', list: ['Male', 'Female']},
{type: 'exclusion', field: 'username', list: ['Admin', 'Operator']},
{type: 'format', field: 'username', matcher: /([a-z]+)[0-9]{2,3}/}
]
}
});
The validations can be run by simply calling the validate function, which returns a Ext.data.Errors object:
var instance = Ext.create('User', {
name: 'Ed',
gender: 'Male',
username: 'edspencer'
});
var errors = instance.validate();
Associations
Models can have associations with other Models via Ext.data.association.HasOne, belongsTo and hasMany associations. For example, let's say we're writing a blog administration application which deals with Users, Posts and Comments. We can express the relationships between these models like this:
Ext.define('Post', {
extend: 'Ext.data.Model',
config: {
fields: ['id', 'user_id'],
belongsTo: 'User',
hasMany : {model: 'Comment', name: 'comments'}
}
});
Ext.define('Comment', {
extend: 'Ext.data.Model',
config: {
fields: ['id', 'user_id', 'post_id'],
belongsTo: 'Post'
}
});
Ext.define('User', {
extend: 'Ext.data.Model',
config: {
fields: ['id'],
hasMany: [
'Post',
{model: 'Comment', name: 'comments'}
]
}
});
See the docs for Ext.data.association.HasOne, Ext.data.association.BelongsTo and Ext.data.association.HasMany for details on the usage and configuration of associations. Note that associations can also be specified like this:
Ext.define('User', {
extend: 'Ext.data.Model',
config: {
fields: ['id'],
associations: [
{type: 'hasMany', model: 'Post', name: 'posts'},
{type: 'hasMany', model: 'Comment', name: 'comments'}
]
}
});
Using a Proxy
Models are great for representing types of data and relationships, but sooner or later we're going to want to load or save that data somewhere. All loading and saving of data is handled via a Proxy, which can be set directly on the Model:
Ext.define('User', {
extend: 'Ext.data.Model',
config: {
fields: ['id', 'name', 'email'],
proxy: {
type: 'rest',
url : '/users'
}
}
});
Here we've set up a Rest Proxy, which knows how to load and save data to and from a RESTful backend. Let's see how this works:
var user = Ext.create('User', {name: 'Ed Spencer', email: 'ed@sencha.com'});
user.save(); //POST /users
Calling save on the new Model instance tells the configured RestProxy that we wish to persist this Model's data onto our server. RestProxy figures out that this Model hasn't been saved before because it doesn't have an id, and performs the appropriate action - in this case issuing a POST request to the url we configured (/users). We configure any Proxy on any Model and always follow this API - see Ext.data.proxy.Proxy for a full list.
Loading data via the Proxy is equally easy:
//get a reference to the User model class
var User = Ext.ModelManager.getModel('User');
//Uses the configured RestProxy to make a GET request to /users/123
User.load(123, {
success: function(user) {
console.log(user.getId()); //logs 123
}
});
Models can also be updated and destroyed easily:
//the user Model we loaded in the last snippet:
user.set('name', 'Edward Spencer');
//tells the Proxy to save the Model. In this case it will perform a PUT request to /users/123 as this Model already has an id
user.save({
success: function() {
console.log('The User was updated');
}
});
//tells the Proxy to destroy the Model. Performs a DELETE request to /users/123
user.erase({
success: function() {
console.log('The User was destroyed!');
}
});
Usage in Stores
It is very common to want to load a set of Model instances to be displayed and manipulated in the UI. We do this by creating a Store:
var store = Ext.create('Ext.data.Store', {
model: 'User'
});
//uses the Proxy we set up on Model to load the Store data
store.load();
A Store is just a collection of Model instances - usually loaded from a server somewhere. Store can also maintain a set of added, updated and removed Model instances to be synchronized with the server via the Proxy. See the Store docs for more information on Stores.
Available since: 1.1.0
Config options
An array of associations for this model.
An array of associations for this model.
Available since: 2.0.0
One or more BelongsTo associations for this model.
One or more BelongsTo associations for this model.
Available since: 2.0.0
The event name to bubble, or an Array of event names.
The event name to bubble, or an Array of event names.
Available since: 2.0.0
The name of a property that is used for submitting this Model's unique client-side identifier to the server when multiple phantom records are saved as part of the same Operation. In such a case, the server response should include the client id for each record so that the server response data can be used to update the client-side records if necessary. This property cannot have the same name as any of this Model's fields. Defaults to 'clientId'.
Defaults to: 'clientId'
Available since: 2.0.0
The field definitions for all instances of this Model. Note: this does not set the values of each field on an instance, it sets the collection of fields itself. Sample usage:
Ext.define('MyApp.model.User', {
extend: 'Ext.data.Model',
config: {
fields: [
'id',
{name: 'age', type: 'int'},
{name: 'taxRate', type: 'float'}
]
}
});
Available since: 2.0.0
One or more HasMany associations for this model.
One or more HasMany associations for this model.
Available since: 2.0.0
One or more HasOne associations for this model.
One or more HasOne associations for this model.
Available since: 2.0.0
The name of the field treated as this Model's unique id. Defaults to 'id'. Note that this field needs to have a type of 'auto'. Setting the field type to anything else will be undone by the framework. This is because new records that are created without an id, will have one generated. This generated id is a string.
Defaults to: 'id'
Available since: 1.1.0
The identifier strategy used when creating new instances of this Model that don't have an id defined. By default this uses the simple identifier strategy that generates id's like 'ext-record-12'. If you are saving these records in localstorage using a LocalStorage proxy you need to ensure that this identifier strategy is set to something that always generates unique id's. We provide one strategy by default that generates these unique id's which is the uuid strategy.
Defaults to: {type: 'simple'}
Available since: 2.0.0
A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.
See the Event guide for more
Note it is bad practice to specify a listeners config when you are defining a class using Ext.define. Instead, only specify listeners when you are instantiating your class with Ext.create.
Available since: 1.1.0
The string type of the default Model Proxy. Defaults to null.
Available since: 2.0.0
An array of validations for this model.
An array of validations for this model.
Available since: 2.0.0
Properties
Instance Properties The associations defined on this model.
The associations defined on this model.
Available since: 2.0.0
True if this Record has been modified. ...True if this Record has been modified. Read-only.
Defaults to: false
Available since: 1.1.0
Internal flag used to track whether or not the model instance is currently being edited. ...Internal flag used to track whether or not the model instance is currently being edited. Read-only.
Defaults to: false
Available since: 1.1.0
Provides an easy way to quickly determine if a given class is a Model ...Provides an easy way to quickly determine if a given class is a Model
Defaults to: true
Available since: 1.1.0
listenerOptionsRegex : RegExpprivate ...
Defaults to: /^(?:delegate|single|delay|buffer|args|prepend)$/
Available since: 2.0.0
mixinConfig : Objectprivate ...
Defaults to: {id: 'observable', hooks: {destroy: 'destroy'}}
Available since: 2.0.0
key/value pairs of all fields whose values have changed. ...key/value pairs of all fields whose values have changed.
The value is the original value for the field.
Available since: 1.1.0
True when the record does not yet exist in a server-side database (see setDirty). ...True when the record does not yet exist in a server-side database (see setDirty).
Any record which has a real database pk set as its id property is NOT a phantom -- it's real.
Defaults to: false
Available since: 1.1.0
The raw data used to create this model if created via a reader.
The raw data used to create this model if created via a reader.
Available since: 2.0.0
Get the reference to the current class from which this object was instantiated. ...Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); / dependentOL on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 2.0.0
staticConfigs : Arrayprivate ...
Defaults to: ['idProperty', 'fields', 'validations', 'associations', 'hasMany', 'hasOne', 'belongsTo', 'clientIdProperty', 'identifier', 'proxy']
Available since: 2.0.0
An array of Ext.data.Store objects that this record is bound to.
An array of Ext.data.Store objects that this record is bound to.
Available since: 2.0.0
The associations defined on this model.
The associations defined on this model.
Available since: 2.0.0
True if this Record has been modified. Read-only.
Defaults to: false
Available since: 1.1.0
Internal flag used to track whether or not the model instance is currently being edited. Read-only.
Defaults to: false
Available since: 1.1.0
Provides an easy way to quickly determine if a given class is a Model
Defaults to: true
Available since: 1.1.0
Defaults to: /^(?:delegate|single|delay|buffer|args|prepend)$/
Available since: 2.0.0
Defaults to: {id: 'observable', hooks: {destroy: 'destroy'}}
Available since: 2.0.0
key/value pairs of all fields whose values have changed. The value is the original value for the field.
Available since: 1.1.0
True when the record does not yet exist in a server-side database (see setDirty). Any record which has a real database pk set as its id property is NOT a phantom -- it's real.
Defaults to: false
Available since: 1.1.0
The raw data used to create this model if created via a reader.
The raw data used to create this model if created via a reader.
Available since: 2.0.0
Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); / dependentOL on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 2.0.0
Defaults to: ['idProperty', 'fields', 'validations', 'associations', 'hasMany', 'hasOne', 'belongsTo', 'clientIdProperty', 'identifier', 'proxy']
Available since: 2.0.0
An array of Ext.data.Store objects that this record is bound to.
An array of Ext.data.Store objects that this record is bound to.
Available since: 2.0.0
Static Properties
Methods
Instance Methods Creates new Model instance. ...Creates new Model instance.
Available since: 1.1.0
Parameters
- data : Object
An object containing keys corresponding to this model's fields, and their associated values
- id : Number (optional)
Unique ID to assign to this model instance
Returns
Overrides: Ext.mixin.Observable.constructor
addAfterListener( eventName, fn, [scope], [options] )Appends an after-event handler. ...Appends an after-event handler.
Same as addListener with order set to 'after'.
Available since: 2.0.0
Parameters
addAssociations( associations, defaultType )private addBeforeListener( eventName, fn, [scope], [options] )Appends a before-event handler. ...Appends a before-event handler. Returning false from the handler will stop the event.
Same as addListener with order set to 'before'.
Available since: 2.0.0
Parameters
addDispatcherListener( selector, name, fn, scope, options, order )private addEvents( eventNames )deprecatedAdds the specified events to the list of events which this Observable may fire. ...Adds the specified events to the list of events which this Observable may fire.
This method has been deprecated since 2.0
It's no longer needed to add events before firing.
Available since: 1.1.0
Parameters
addListener( eventName, fn, [scope], [options], [order] )Appends an event handler to this object. ...Appends an event handler to this object. You can review the available handlers by looking at the 'events'
section of the documentation for the component you are working with.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener:
container.on('tap', this.handleTap, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which
specify multiple events. For example:
container.on({
tap : this.onTap,
swipe: this.onSwipe,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
container.on({
tap : { fn: this.onTap, scope: this, single: true },
swipe: { fn: button.onSwipe, scope: button }
});
See the Events Guide for more.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are
event names.
- fn : Function
The method the event invokes. Will be called with arguments given to
fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is executed. If
omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
This object may contain any of the following properties:
scope : Object
The scope (this reference) in which the handler function is executed. If omitted, defaults to the object
which fired the event.
delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
order : String
The order of when the listener should be added into the listener queue.
If you set an order of before and the event you are listening to is preventable, you can return false and it will stop the event.
Available options are before, current and after. Defaults to current.
buffer : Number
Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that
time, the original handler is not invoked, but the new handler is scheduled in its place.
element : String
Allows you to add a listener onto a element of this component using the elements reference.
Ext.create('Ext.Component', {
listeners: {
element: 'element',
tap: function() {
console.log('element tap!');
}
}
});
All components have the element reference, which is the outer most element of the component. Ext.Container also has the
innerElement element which contains all children. In most cases element is adequate.
delegate : String
Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.
// Create a container with a two children; a button and a toolbar
var container = Ext.create('Ext.Container', {
items: [
{
xtype: 'toolbar',
docked: 'top',
title: 'My Toolbar'
},
{
xtype: 'button',
text: 'My Button'
}
]
});
container.on({
// Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate
delegate: 'button',
tap: function() {
alert('Button tapped!');
}
});
- order : String (optional)
The order of when the listener should be added into the listener queue.
Possible values are before, current and after.
Defaults to: 'current'
addManagedListener( object, eventName, [fn], [scope], [options] )deprecatedAdds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed. ...Adds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed.
This method has been deprecated since 2.0
All listeners are now automatically managed where necessary. Simply use addListener.
Available since: 1.1.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the eventName parameter was an event name, this is the handler function.
- scope : Object (optional)
If the eventName parameter was an event name, this is the scope in which
the handler function is executed.
- options : Object (optional)
If the eventName parameter was an event name, this is the
addListener options.
afterCommit( modified )private afterEdit( modifiedFieldNames )private afterReject( )private applyProxy( proxy, currentProxy )private beginEdit( )Begins an edit. ...Begins an edit. While in edit mode, no events (e.g.. the update event) are relayed to the containing store.
When an edit has begun, it must be followed by either endEdit or cancelEdit.
Available since: 2.0.0
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: functi...Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 2.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. ...Call the "parent" method of the current method. That is the method previously
overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
Available since: 2.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
cancelEdit( )Cancels all changes made in the current edit operation. ...Cancels all changes made in the current edit operation.
Available since: 2.0.0
changeListener( operation, eventName, fn, scope, options, order )private changedWhileEditing( ) : BooleanprivateChecks if the underlying data has changed during an edit. ...Checks if the underlying data has changed during an edit. This doesn't necessarily
mean the record is dirty, however we still need to notify the store since it may need
to update any views.
Available since: 2.0.0
Returns
- Boolean
True if the underlying data has changed during an edit.
Removes all listeners for this object. ...Removes all listeners for this object.
Available since: 1.1.0
commit( [silent] )Usually called by the Ext.data.Store which owns the model instance. ...Usually called by the Ext.data.Store which owns the model instance. Commits all changes made to the
instance since either creation or the last commit operation.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of commit
operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change.
Defaults to false.
Creates a copy (clone) of this Model instance. ...Creates a copy (clone) of this Model instance.
Available since: 1.1.0
Parameters
- id : String
A new id. If you don't specify this a new id will be generated for you.
To generate a phantom instance with a new id use:
var rec = record.copy(); // clone the record with a new id
Returns
destroy( )Destroys this model instance. ...Destroys this model instance. Note that this doesn't do a 'destroy' operation. If you want to destroy
the record in your localstorage or on the server you should use the erase method.
Available since: 2.0.0
Overrides: Ext.mixin.Observable.destroy
doAddListener( name, fn, scope, options )private doFireEvent( eventName, args, action, connectedController )private doRemoveListener( name, fn, scope, options, order )private enableBubble( events )Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. ... endEdit( silent, modifiedFieldNames ) Destroys the record using the configured proxy. ...Destroys the record using the configured proxy. This will create a 'destroy' operation.
Note that this doesn't destroy this instance after the server comes back with a response.
It will however call afterErase on any Stores it is joined to. Stores by default will
automatically remove this instance from their data collection.
Available since: 2.0.0
Parameters
- options : Object/Function
Options to pass to the proxy. Config object for Ext.data.Operation.
If you pass a function, this will automatically become the callback method. For convenience the config
object may also contain success and failure methods in addition to callback - they will all be invoked
with the Model and Operation as arguments.
- scope : Object
The scope to run your callback method in. This is only used if you passed a function
as the first argument.
Returns
- Ext.data.Model
The Model instance
fireAction( eventName, args, fn, scope )Fires the specified event with the passed parameters and execute a function (action)
at the end if there are no liste...Fires the specified event with the passed parameters and execute a function (action)
at the end if there are no listeners that return false.
Available since: 2.0.0
Parameters
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addList...Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
The first argument is the name of the event. Every other argument passed will be available when you listen for
the event.
Example
Firstly, we set up a listener for our new event.
this.on('myevent', function(arg1, arg2, arg3, arg4, options, e) {
console.log(arg1); // true
console.log(arg2); // 2
console.log(arg3); // { test: 'foo' }
console.log(arg4); // 14
console.log(options); // the options added when adding the listener
console.log(e); // the event object with information about the event
});
And then we can fire off the event.
this.fireEvent('myevent', true, 2, { test: 'foo' }, 14);
An event may be set to bubble up an Observable parent hierarchy by calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
getAssociatedData( ) : ObjectGets all of the data from this Models loaded associations. ...Gets all of the data from this Models loaded associations. It does this recursively - for example if we have a
User which hasMany Orders, and each Order hasMany OrderItems, it will return an object like this:
{
orders: [
{
id: 123,
status: 'shipped',
orderItems: [
...
]
}
]
}
Available since: 2.0.0
Returns
- Object
The nested data set for the Model's loaded associations
getChanges( ) : ObjectGets a hash of only the fields that have been modified since this Model was created or commited. ...Gets a hash of only the fields that have been modified since this Model was created or commited.
Available since: 1.1.0
Returns
Returns an object containing the data set on this record. ...Returns an object containing the data set on this record. This method also allows you to
retrieve all the associated data. Note that if you should always use this method if you
need all the associated data, since the data property on the record instance is not
ensured to be updated at all times.
Available since: 2.0.0
Parameters
- includeAssociated : Boolean
True to include the associated data.
Returns
- Object
The data
getFieldName( field )privateThis method is used by the fields collection to retrieve the key for a field
based on it's name. ...This method is used by the fields collection to retrieve the key for a field
based on it's name.
Available since: 2.0.0
Parameters
- field : Object
Returns the unique ID allocated to this model instance as defined by idProperty. ...Returns the unique ID allocated to this model instance as defined by idProperty.
Available since: 1.1.0
Returns
Overrides: Ext.mixin.Identifiable.getId
getIsErased( )Returns true if the record has been erased on the server. ...Returns true if the record has been erased on the server.
Available since: 2.0.0
getListeners( ) : Object getManagedListeners( object, eventName )private Initialize configuration for this class. ...Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 2.0.0
Parameters
- instanceConfig : Object
Returns
- Object
mixins The mixin prototypes as key - value pairs
join( store )By joining this model to an instance of a class, this model will automatically try to
call certain template methods o...By joining this model to an instance of a class, this model will automatically try to
call certain template methods on that instance (afterEdit, afterCommit, afterErase).
For example, a Store calls join and unjoin whenever you add or remove a record to it's data collection.
This way a Store can get notified of any changes made to this record.
This functionality is usually only required when creating custom components.
Available since: 1.1.0
Parameters
- store : Ext.data.Store
The store to which this model has been added.
Private function that is used when you create a record that already exists in the model cache. ...Private function that is used when you create a record that already exists in the model cache.
In this case we loop over each field, and apply any data to the current instance that is not already
marked as being dirty on that instance.
Available since: 2.0.0
Parameters
- data : Object
Returns
- Ext.data.Model
this
mon( object, eventName, [fn], [scope], [options] )deprecatedAlias for addManagedListener. ...Alias for addManagedListener.
Adds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed.
This method has been deprecated since 2.0.0
This is now done automatically
Available since: 2.0.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the eventName parameter was an event name, this is the handler function.
- scope : Object (optional)
If the eventName parameter was an event name, this is the scope in which
the handler function is executed.
- options : Object (optional)
If the eventName parameter was an event name, this is the
addListener options.
mun( object, eventName, [fn], [scope] )deprecatedAlias for removeManagedListener. ...Alias for removeManagedListener.
Adds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed.
This method has been deprecated since 2.0.0
This is now done automatically
Available since: 2.0.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the eventName parameter was an event name, this is the handler function.
- scope : Object (optional)
If the eventName parameter was an event name, this is the scope in which
the handler function is executed.
notifyStores( fn )privateHelper function used by afterEdit, afterReject and afterCommit. ...Helper function used by afterEdit, afterReject and afterCommit. Calls the given method on the
store that this instance has joined, if any. The store function
will always be called with the model instance as its single argument.
Available since: 2.0.0
Parameters
- fn : String
The function to call on the store
on( eventName, fn, [scope], [options], [order] )Alias for addListener. ...Alias for addListener.
Appends an event handler to this object. You can review the available handlers by looking at the 'events'
section of the documentation for the component you are working with.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener:
container.on('tap', this.handleTap, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which
specify multiple events. For example:
container.on({
tap : this.onTap,
swipe: this.onSwipe,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
container.on({
tap : { fn: this.onTap, scope: this, single: true },
swipe: { fn: button.onSwipe, scope: button }
});
See the Events Guide for more.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are
event names.
- fn : Function
The method the event invokes. Will be called with arguments given to
fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is executed. If
omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
This object may contain any of the following properties:
scope : Object
The scope (this reference) in which the handler function is executed. If omitted, defaults to the object
which fired the event.
delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
order : String
The order of when the listener should be added into the listener queue.
If you set an order of before and the event you are listening to is preventable, you can return false and it will stop the event.
Available options are before, current and after. Defaults to current.
buffer : Number
Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that
time, the original handler is not invoked, but the new handler is scheduled in its place.
element : String
Allows you to add a listener onto a element of this component using the elements reference.
Ext.create('Ext.Component', {
listeners: {
element: 'element',
tap: function() {
console.log('element tap!');
}
}
});
All components have the element reference, which is the outer most element of the component. Ext.Container also has the
innerElement element which contains all children. In most cases element is adequate.
delegate : String
Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.
// Create a container with a two children; a button and a toolbar
var container = Ext.create('Ext.Container', {
items: [
{
xtype: 'toolbar',
docked: 'top',
title: 'My Toolbar'
},
{
xtype: 'button',
text: 'My Button'
}
]
});
container.on({
// Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate
delegate: 'button',
tap: function() {
alert('Button tapped!');
}
});
- order : String (optional)
The order of when the listener should be added into the listener queue.
Possible values are before, current and after.
Defaults to: 'current'
onAfter( eventName, fn, [scope], [options] )Alias for addAfterListener. ...Alias for addAfterListener.
Appends an after-event handler.
Same as addListener with order set to 'after'.
Available since: 2.0.0
Parameters
onBefore( eventName, fn, [scope], [options] )Alias for addBeforeListener. ...Alias for addBeforeListener.
Appends a before-event handler. Returning false from the handler will stop the event.
Same as addListener with order set to 'before'.
Available since: 2.0.0
Parameters
onClassExtended( cls, data, hooks )private ... onConfigUpdate( names, callback, scope )private This complex-looking method takes a given Model instance and returns an object containing all data from
all of that M...This complex-looking method takes a given Model instance and returns an object containing all data from
all of that Model's loaded associations. See getAssociatedData
Available since: 2.0.0
Parameters
- record : Ext.data.Model
The Model instance
- ids : String[]
PRIVATE. The set of Model instance internalIds that have already been loaded
- associationType : String (optional)
The name of the type of association to limit to.
Returns
- Object
The nested data set for the Model's loaded associations
reject( [silent] )Usually called by the Ext.data.Store to which this model instance has been joined. ...Usually called by the Ext.data.Store to which this model instance has been joined. Rejects
all changes made to the model instance since either creation, or the last commit operation. Modified fields are
reverted to their original values.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of reject
operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change.
Defaults to false.
Relays selected events from the specified Observable as if the events were fired by this. ... removeAfterListener( eventName, fn, [scope], [options] )Removes a before-event handler. ...Removes a before-event handler.
Same as removeListener with order set to 'after'.
Available since: 2.0.0
Parameters
removeBeforeListener( eventName, fn, [scope], [options] )Removes a before-event handler. ...Removes a before-event handler.
Same as removeListener with order set to 'before'.
Available since: 2.0.0
Parameters
removeDispatcherListener( selector, name, fn, scope, order )private removeListener( eventName, fn, [scope], [options], [order] )Removes an event handler. ...Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
- options : Object (optional)
Extra options object. See addListener for details.
- order : String (optional)
The order of the listener to remove.
Possible values are before, current and after.
Defaults to: 'current'
removeManagedListener( object, eventName, [fn], [scope] )deprecatedAdds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed. ...Adds listeners to any Observable object (or Element) which are automatically removed when this Component
is destroyed.
This method has been deprecated since 2.0
All listeners are now automatically managed where necessary. Simply use removeListener.
Available since: 1.1.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the eventName parameter was an event name, this is the handler function.
- scope : Object (optional)
If the eventName parameter was an event name, this is the scope in which
the handler function is executed.
resumeEvents( )Resumes firing events (see suspendEvents). ...Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 1.1.0
Saves the model instance using the configured proxy. ...Saves the model instance using the configured proxy.
Available since: 1.1.0
Parameters
- options : Object/Function
Options to pass to the proxy. Config object for Ext.data.Operation.
If you pass a function, this will automatically become the callback method. For convenience the config
object may also contain success and failure methods in addition to callback - they will all be invoked
with the Model and Operation as arguments.
- scope : Object
The scope to run your callback method in. This is only used if you passed a function
as the first argument.
Returns
- Ext.data.Model
The Model instance
set( fieldName, value ) setBelongsTo( belongsTo ) This method is used to set the data for this Record instance. ...This method is used to set the data for this Record instance.
Note that the existing data is removed. If a field is not specified
in the passed data it will use the field's default value. If a convert
method is specified for the field it will be called on the value.
Available since: 2.0.0
Parameters
- rawData : Object
Returns
- Ext.data.Model
this This Record
setDirty( )Marks this Record as dirty. ...Marks this Record as dirty. This method is used interally when adding phantom records
to a writer enabled store.
Marking a record dirty causes the phantom to be returned by Ext.data.Store.getUpdatedRecords
where it will have a create action composed for it during model save operations.
Available since: 1.1.0
setFields( )Updates the collection of Fields that all instances of this Model use. ...Updates the collection of Fields that all instances of this Model use. Does not update field values in a Model
instance (use set for that), instead this updates which fields are available on the Model class. This
is normally used when creating or updating Model definitions dynamically, for example if you allow your users to
define their own Models and save the fields configuration to a database, this method allows you to change those
fields later.
Available since: 2.0.0
setHasMany( hasMany ) setHasOne( hasOne ) setId( id )Sets the model instance's id field to the given id. ...Sets the model instance's id field to the given id.
Available since: 1.1.0
Parameters
Overrides: Ext.mixin.Identifiable.setId
setListeners( listeners ) sortConvertFields( field1, field2 )privateThis method is being used to sort the fields based on their convert method. ... Get the reference to the class from which this object was instantiated. ...Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 2.0.0
Returns
suspendEvents( queueSuspended )Suspends the firing of all events. ...Suspends the firing of all events. (see resumeEvents)
Available since: 1.1.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired
after the resumeEvents call instead of discarding all suspended events.
Returns a url-suitable string for this model instance. ...Returns a url-suitable string for this model instance. By default this just returns the name of the Model class
followed by the instance ID - for example an instance of MyApp.model.User with ID 123 will return 'user/123'.
Available since: 2.0.0
Returns
- String
The url string for this model instance
un( eventName, fn, [scope], [options], [order] )Alias for removeListener. ...Alias for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
- options : Object (optional)
Extra options object. See addListener for details.
- order : String (optional)
The order of the listener to remove.
Possible values are before, current and after.
Defaults to: 'current'
unAfter( eventName, fn, [scope], [options] )Alias for removeAfterListener. ...Alias for removeAfterListener.
Removes a before-event handler.
Same as removeListener with order set to 'after'.
Available since: 2.0.0
Parameters
unBefore( eventName, fn, [scope], [options] )Alias for removeBeforeListener. ...Alias for removeBeforeListener.
Removes a before-event handler.
Same as removeListener with order set to 'before'.
Available since: 2.0.0
Parameters
unjoin( store )This unjoins this record from an instance of a class. ...This unjoins this record from an instance of a class. Look at the documentation for join
for more information about joining records to class instances.
Available since: 1.1.0
Parameters
- store : Ext.data.Store
The store from which this model has been removed.
validate( ) : Ext.data.ErrorsValidates the current data against all of its configured validations. ...Validates the current data against all of its configured validations.
Available since: 1.1.0
Returns
- Ext.data.Errors
The errors object
Creates new Model instance.
Available since: 1.1.0
Parameters
- data : Object
An object containing keys corresponding to this model's fields, and their associated values
- id : Number (optional)
Unique ID to assign to this model instance
Returns
Overrides: Ext.mixin.Observable.constructor
Appends an after-event handler.
Same as addListener with order set to 'after'.
Available since: 2.0.0
Parameters
Appends a before-event handler. Returning false from the handler will stop the event.
Same as addListener with order set to 'before'.
Available since: 2.0.0
Parameters
Adds the specified events to the list of events which this Observable may fire.
This method has been deprecated since 2.0
It's no longer needed to add events before firing.
Available since: 1.1.0
Parameters
Appends an event handler to this object. You can review the available handlers by looking at the 'events' section of the documentation for the component you are working with.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener:
container.on('tap', this.handleTap, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
container.on({
tap : this.onTap,
swipe: this.onSwipe,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
container.on({
tap : { fn: this.onTap, scope: this, single: true },
swipe: { fn: button.onSwipe, scope: button }
});
See the Events Guide for more.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function
The method the event invokes. Will be called with arguments given to fireEvent plus the
optionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
This object may contain any of the following properties:
scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event.delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
order : String
The order of when the listener should be added into the listener queue.
If you set an order of
beforeand the event you are listening to is preventable, you can returnfalseand it will stop the event.Available options are
before,currentandafter. Defaults tocurrent.buffer : Number
Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
element : String
Allows you to add a listener onto a element of this component using the elements reference.
Ext.create('Ext.Component', { listeners: { element: 'element', tap: function() { console.log('element tap!'); } } });All components have the
elementreference, which is the outer most element of the component. Ext.Container also has theinnerElementelement which contains all children. In most caseselementis adequate.delegate : String
Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.
// Create a container with a two children; a button and a toolbar var container = Ext.create('Ext.Container', { items: [ { xtype: 'toolbar', docked: 'top', title: 'My Toolbar' }, { xtype: 'button', text: 'My Button' } ] }); container.on({ // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate delegate: 'button', tap: function() { alert('Button tapped!'); } });
- order : String (optional)
The order of when the listener should be added into the listener queue. Possible values are
before,currentandafter.Defaults to:
'current'
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.
This method has been deprecated since 2.0
All listeners are now automatically managed where necessary. Simply use addListener.
Available since: 1.1.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
eventNameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
eventNameparameter was an event name, this is the scope in which the handler function is executed. - options : Object (optional)
If the
eventNameparameter was an event name, this is the addListener options.
Begins an edit. While in edit mode, no events (e.g.. the update event) are relayed to the containing store.
When an edit has begun, it must be followed by either endEdit or cancelEdit.
Available since: 2.0.0
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callOverridden();
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
Available since: 2.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. That is the method previously overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
Available since: 2.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
Cancels all changes made in the current edit operation.
Available since: 2.0.0
Checks if the underlying data has changed during an edit. This doesn't necessarily mean the record is dirty, however we still need to notify the store since it may need to update any views.
Available since: 2.0.0
Returns
- Boolean
True if the underlying data has changed during an edit.
Removes all listeners for this object.
Available since: 1.1.0
Usually called by the Ext.data.Store which owns the model instance. Commits all changes made to the instance since either creation or the last commit operation.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of commit operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change. Defaults to false.
Creates a copy (clone) of this Model instance.
Available since: 1.1.0
Parameters
- id : String
A new id. If you don't specify this a new id will be generated for you. To generate a phantom instance with a new id use:
var rec = record.copy(); // clone the record with a new id
Returns
Destroys this model instance. Note that this doesn't do a 'destroy' operation. If you want to destroy the record in your localstorage or on the server you should use the erase method.
Available since: 2.0.0
Overrides: Ext.mixin.Observable.destroy
Destroys the record using the configured proxy. This will create a 'destroy' operation. Note that this doesn't destroy this instance after the server comes back with a response. It will however call afterErase on any Stores it is joined to. Stores by default will automatically remove this instance from their data collection.
Available since: 2.0.0
Parameters
- options : Object/Function
Options to pass to the proxy. Config object for Ext.data.Operation. If you pass a function, this will automatically become the callback method. For convenience the config object may also contain
successandfailuremethods in addition tocallback- they will all be invoked with the Model and Operation as arguments. - scope : Object
The scope to run your callback method in. This is only used if you passed a function as the first argument.
Returns
- Ext.data.Model
The Model instance
Fires the specified event with the passed parameters and execute a function (action) at the end if there are no listeners that return false.
Available since: 2.0.0
Parameters
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
The first argument is the name of the event. Every other argument passed will be available when you listen for the event.
Example
Firstly, we set up a listener for our new event.
this.on('myevent', function(arg1, arg2, arg3, arg4, options, e) {
console.log(arg1); // true
console.log(arg2); // 2
console.log(arg3); // { test: 'foo' }
console.log(arg4); // 14
console.log(options); // the options added when adding the listener
console.log(e); // the event object with information about the event
});
And then we can fire off the event.
this.fireEvent('myevent', true, 2, { test: 'foo' }, 14);
An event may be set to bubble up an Observable parent hierarchy by calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
Gets all of the data from this Models loaded associations. It does this recursively - for example if we have a User which hasMany Orders, and each Order hasMany OrderItems, it will return an object like this:
{
orders: [
{
id: 123,
status: 'shipped',
orderItems: [
...
]
}
]
}
Available since: 2.0.0
Returns
- Object
The nested data set for the Model's loaded associations
Gets a hash of only the fields that have been modified since this Model was created or commited.
Available since: 1.1.0
Returns
Returns an object containing the data set on this record. This method also allows you to retrieve all the associated data. Note that if you should always use this method if you need all the associated data, since the data property on the record instance is not ensured to be updated at all times.
Available since: 2.0.0
Parameters
- includeAssociated : Boolean
True to include the associated data.
Returns
- Object
The data
This method is used by the fields collection to retrieve the key for a field based on it's name.
Available since: 2.0.0
Parameters
- field : Object
Returns the unique ID allocated to this model instance as defined by idProperty.
Available since: 1.1.0
Returns
Overrides: Ext.mixin.Identifiable.getId
Returns true if the record has been erased on the server.
Available since: 2.0.0
Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 2.0.0
Parameters
- instanceConfig : Object
Returns
- Object
mixins The mixin prototypes as key - value pairs
By joining this model to an instance of a class, this model will automatically try to call certain template methods on that instance (afterEdit, afterCommit, afterErase). For example, a Store calls join and unjoin whenever you add or remove a record to it's data collection. This way a Store can get notified of any changes made to this record. This functionality is usually only required when creating custom components.
Available since: 1.1.0
Parameters
- store : Ext.data.Store
The store to which this model has been added.
Private function that is used when you create a record that already exists in the model cache. In this case we loop over each field, and apply any data to the current instance that is not already marked as being dirty on that instance.
Available since: 2.0.0
Parameters
- data : Object
Returns
- Ext.data.Model
this
Alias for addManagedListener.
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.
This method has been deprecated since 2.0.0
This is now done automatically
Available since: 2.0.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
eventNameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
eventNameparameter was an event name, this is the scope in which the handler function is executed. - options : Object (optional)
If the
eventNameparameter was an event name, this is the addListener options.
Alias for removeManagedListener.
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.
This method has been deprecated since 2.0.0
This is now done automatically
Available since: 2.0.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
eventNameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
eventNameparameter was an event name, this is the scope in which the handler function is executed.
Helper function used by afterEdit, afterReject and afterCommit. Calls the given method on the store that this instance has joined, if any. The store function will always be called with the model instance as its single argument.
Available since: 2.0.0
Parameters
- fn : String
The function to call on the store
Alias for addListener.
Appends an event handler to this object. You can review the available handlers by looking at the 'events' section of the documentation for the component you are working with.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener:
container.on('tap', this.handleTap, this, {
single: true,
delay: 100
});
Attaching multiple handlers in 1 call
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
container.on({
tap : this.onTap,
swipe: this.onSwipe,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
container.on({
tap : { fn: this.onTap, scope: this, single: true },
swipe: { fn: button.onSwipe, scope: button }
});
See the Events Guide for more.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function
The method the event invokes. Will be called with arguments given to fireEvent plus the
optionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
This object may contain any of the following properties:
scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event.delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
order : String
The order of when the listener should be added into the listener queue.
If you set an order of
beforeand the event you are listening to is preventable, you can returnfalseand it will stop the event.Available options are
before,currentandafter. Defaults tocurrent.buffer : Number
Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
element : String
Allows you to add a listener onto a element of this component using the elements reference.
Ext.create('Ext.Component', { listeners: { element: 'element', tap: function() { console.log('element tap!'); } } });All components have the
elementreference, which is the outer most element of the component. Ext.Container also has theinnerElementelement which contains all children. In most caseselementis adequate.delegate : String
Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.
// Create a container with a two children; a button and a toolbar var container = Ext.create('Ext.Container', { items: [ { xtype: 'toolbar', docked: 'top', title: 'My Toolbar' }, { xtype: 'button', text: 'My Button' } ] }); container.on({ // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate delegate: 'button', tap: function() { alert('Button tapped!'); } });
- order : String (optional)
The order of when the listener should be added into the listener queue. Possible values are
before,currentandafter.Defaults to:
'current'
Alias for addAfterListener.
Appends an after-event handler.
Same as addListener with order set to 'after'.
Available since: 2.0.0
Parameters
Alias for addBeforeListener.
Appends a before-event handler. Returning false from the handler will stop the event.
Same as addListener with order set to 'before'.
Available since: 2.0.0
Parameters
This complex-looking method takes a given Model instance and returns an object containing all data from all of that Model's loaded associations. See getAssociatedData
Available since: 2.0.0
Parameters
- record : Ext.data.Model
The Model instance
- ids : String[]
PRIVATE. The set of Model instance internalIds that have already been loaded
- associationType : String (optional)
The name of the type of association to limit to.
Returns
- Object
The nested data set for the Model's loaded associations
Usually called by the Ext.data.Store to which this model instance has been joined. Rejects all changes made to the model instance since either creation, or the last commit operation. Modified fields are reverted to their original values.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of reject operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change. Defaults to false.
Removes a before-event handler.
Same as removeListener with order set to 'after'.
Available since: 2.0.0
Parameters
Removes a before-event handler.
Same as removeListener with order set to 'before'.
Available since: 2.0.0
Parameters
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
- options : Object (optional)
Extra options object. See addListener for details.
- order : String (optional)
The order of the listener to remove. Possible values are
before,currentandafter.Defaults to:
'current'
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.
This method has been deprecated since 2.0
All listeners are now automatically managed where necessary. Simply use removeListener.
Available since: 1.1.0
Parameters
- object : Ext.mixin.Observable/HTMLElement
The item to which to add a listener/listeners.
- eventName : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
eventNameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
eventNameparameter was an event name, this is the scope in which the handler function is executed.
Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 1.1.0
Saves the model instance using the configured proxy.
Available since: 1.1.0
Parameters
- options : Object/Function
Options to pass to the proxy. Config object for Ext.data.Operation. If you pass a function, this will automatically become the callback method. For convenience the config object may also contain
successandfailuremethods in addition tocallback- they will all be invoked with the Model and Operation as arguments. - scope : Object
The scope to run your callback method in. This is only used if you passed a function as the first argument.
Returns
- Ext.data.Model
The Model instance
This method is used to set the data for this Record instance. Note that the existing data is removed. If a field is not specified in the passed data it will use the field's default value. If a convert method is specified for the field it will be called on the value.
Available since: 2.0.0
Parameters
- rawData : Object
Returns
- Ext.data.Model
this This Record
Marks this Record as dirty. This method is used interally when adding phantom records
to a writer enabled store.
Marking a record dirty causes the phantom to be returned by Ext.data.Store.getUpdatedRecords
where it will have a create action composed for it during model save operations.
Available since: 1.1.0
Updates the collection of Fields that all instances of this Model use. Does not update field values in a Model instance (use set for that), instead this updates which fields are available on the Model class. This is normally used when creating or updating Model definitions dynamically, for example if you allow your users to define their own Models and save the fields configuration to a database, this method allows you to change those fields later.
Available since: 2.0.0
Sets the model instance's id field to the given id.
Available since: 1.1.0
Parameters
Overrides: Ext.mixin.Identifiable.setId
Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 2.0.0
Returns
Suspends the firing of all events. (see resumeEvents)
Available since: 1.1.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events.
Returns a url-suitable string for this model instance. By default this just returns the name of the Model class followed by the instance ID - for example an instance of MyApp.model.User with ID 123 will return 'user/123'.
Available since: 2.0.0
Returns
- String
The url string for this model instance
Alias for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
- options : Object (optional)
Extra options object. See addListener for details.
- order : String (optional)
The order of the listener to remove. Possible values are
before,currentandafter.Defaults to:
'current'
Alias for removeAfterListener.
Removes a before-event handler.
Same as removeListener with order set to 'after'.
Available since: 2.0.0
Parameters
Alias for removeBeforeListener.
Removes a before-event handler.
Same as removeListener with order set to 'before'.
Available since: 2.0.0
Parameters
This unjoins this record from an instance of a class. Look at the documentation for join for more information about joining records to class instances.
Available since: 1.1.0
Parameters
- store : Ext.data.Store
The store from which this model has been removed.
Validates the current data against all of its configured validations.
Available since: 1.1.0
Returns
- Ext.data.Errors
The errors object
Static Methods addConfig( config, fullMerge )privatestatic addMember( name, member )chainableprivatestatic addMembers( members )chainablestaticAdd methods / properties to the prototype of this class. ...Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.implement({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 2.0.0
Parameters
- members : Object
Add / override static properties of this class. ...Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 2.0.0
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class. ...Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 2.0.0
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class. ...Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 2.0.0
Returns
- Object
the created instance.
createAlias( alias, origin )staticCreate aliases for existing prototype methods. ...Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 2.0.0
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See
flexSetter
- origin : String/Object
The original method name
generateCacheId( record, id )privatestatic Get the current class' name in string format. ...Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 2.0.0
Returns
- String
className
load( id, [config] )staticAsynchronously loads a model instance by id. ...Asynchronously loads a model instance by id. Sample usage:
MyApp.User = Ext.define('User', {
extend: 'Ext.data.Model',
fields: [
{name: 'id', type: 'int'},
{name: 'name', type: 'string'}
]
});
MyApp.User.load(10, {
scope: this,
failure: function(record, operation) {
//do something if the load failed
},
success: function(record, operation) {
//do something if the load succeeded
},
callback: function(record, operation) {
//do something whether the load succeeded or failed
}
});
Available since: 1.1.0
Parameters
mixin( name, mixinClass )privatestatic onExtended( fn, scope )chainableprivatestatic Override members of this class. ...Override members of this class. Overridden methods can be invoked via
callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callParent(arguments);
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define
instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callParent(arguments);
alert("Meeeeoooowwww");
return instance;
}
});
The above accomplishes the same result but can be managed by the Ext.Loader
which can properly order the override and its target class and the build process
can determine whether the override is needed based on the required state of the
target class (My.Cat).
This method has been deprecated since 4.1.0
Please use Ext.define instead
Available since: 2.0.0
Parameters
- members : Object
The properties to add to this class. This should be
specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class
Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.implement({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 2.0.0
Parameters
- members : Object
Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 2.0.0
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 2.0.0
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 2.0.0
Returns
- Object
the created instance.
Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 2.0.0
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See flexSetter
- origin : String/Object
The original method name
Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 2.0.0
Returns
- String
className
Asynchronously loads a model instance by id. Sample usage:
MyApp.User = Ext.define('User', {
extend: 'Ext.data.Model',
fields: [
{name: 'id', type: 'int'},
{name: 'name', type: 'string'}
]
});
MyApp.User.load(10, {
scope: this,
failure: function(record, operation) {
//do something if the load failed
},
success: function(record, operation) {
//do something if the load succeeded
},
callback: function(record, operation) {
//do something whether the load succeeded or failed
}
});
Available since: 1.1.0
Parameters
Override members of this class. Overridden methods can be invoked via callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callParent(arguments);
alert("Meeeeoooowwww");
return instance;
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
var instance = this.callParent(arguments);
alert("Meeeeoooowwww");
return instance;
}
});
The above accomplishes the same result but can be managed by the Ext.Loader which can properly order the override and its target class and the build process can determine whether the override is needed based on the required state of the target class (My.Cat).
This method has been deprecated since 4.1.0
Please use Ext.define instead
Available since: 2.0.0
Parameters
- members : Object
The properties to add to this class. This should be specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class